/* TEMPLATE GENERATED TESTCASE FILE
Filename: CWE191_Integer_Underflow__long_console_readLine_postdec_67b.java
Label Definition File: CWE191_Integer_Underflow.label.xml
Template File: sources-sinks-67b.tmpl.java
*/
/*
 * @description
 * CWE: 191 Integer Underflow
 * BadSource: console_readLine Read data from the console using readLine
 * GoodSource: A hardcoded non-zero, non-min, non-max, even number
 * Sinks: decrement
 *    GoodSink: Ensure there will not be an underflow before decrementing data
 *    BadSink : Decrement data, which can cause an Underflow
 * Flow Variant: 67 Data flow: data passed in a class from one method to another in different source files in the same package
 *
 * */

package testcases.CWE191_Integer_Underflow.s04;
import testcasesupport.*;

public class CWE191_Integer_Underflow__long_console_readLine_postdec_67b
{
    public void badSink(CWE191_Integer_Underflow__long_console_readLine_postdec_67a.Container dataContainer ) throws Throwable
    {
        long data = dataContainer.containerOne;

        /* POTENTIAL FLAW: if data == Long.MIN_VALUE, this will overflow */
        data--;
        long result = (long)(data);

        IO.writeLine("result: " + result);

    }

    /* goodG2B() - use goodsource and badsink */
    public void goodG2BSink(CWE191_Integer_Underflow__long_console_readLine_postdec_67a.Container dataContainer ) throws Throwable
    {
        long data = dataContainer.containerOne;

        /* POTENTIAL FLAW: if data == Long.MIN_VALUE, this will overflow */
        data--;
        long result = (long)(data);

        IO.writeLine("result: " + result);

    }

    /* goodB2G() - use badsource and goodsink */
    public void goodB2GSink(CWE191_Integer_Underflow__long_console_readLine_postdec_67a.Container dataContainer ) throws Throwable
    {
        long data = dataContainer.containerOne;

        /* FIX: Add a check to prevent an underflow from occurring */
        if (data > Long.MIN_VALUE)
        {
            data--;
            long result = (long)(data);
            IO.writeLine("result: " + result);
        }
        else
        {
            IO.writeLine("data value is too small to decrement.");
        }

    }
}
